# -*- coding: utf-8 -*-
"""
Created on Thu Dec 11 20:04:00 2014

@author: viky
"""

import triangle
import triangle.plot
import numpy as np
import matplotlib.pyplot as plt
#define the points of the polygon
A = dict(vertices=np.array(((-5,4), (-11,0), (-5,-4), (5,4),(11,0),(5,-4))))
#triangulate
B = triangle.triangulate(A)
#plot the figure 
triangle.plot.compare(plt, A, B)
plt.show()
a=B['vertices'] #vertices
b=B['triangles'] # getting the indices of vertices
n=len(b) #no. of triangles
#declaring the constants
e=12 #epsilon
z=-5.0 #point in another plane
temp=np.zeros((n,3))
f = open('coordinates', 'w') #file to write meep code
f.write("(set! geometry (list \n") #first line in meep to create geometrical objects
for i in range(0, n):
   print "vertices of %d th triangle" %(i+1)   
   for j in range(0,3):
     print "x coordinate is" + str(a[b[i][j]][0])+ " y coordinate is " + str (a[b[i][j]][1])
     temp[j][0]=a[b[i][j]][0]
     temp[j][1]=a[b[i][j]][1]  
   #defining the centers    
   xc=(temp[0][0]+temp[1][0]+temp[2][0])/2
   yc=(temp[0][1]+temp[1][1]+temp[2][1])/2
   #direction vectors
   e1x=temp[0][0]
   e1y=temp[0][1]
   e2x=temp[1][0]
   e2y=temp[1][1]
   e3x=temp[2][0]
   e3y=temp[2][1] 
   #magnitude of direction vectors
   s1=np.square(e1x)+np.square(e1y)+np.square(z)
   s2=np.square(e2x)+np.square(e2y)+np.square(z)    
   s3=np.square(e3x)+np.square(e3y)+np.square(z) 
   f.write("(make block (center " +str(xc) +" " +str(yc) +" " +str((-z/2)) +") (material ( make dielectric (epsilon " + str(e)+ " ))) (size  (sqrt "+str(s1)+") (sqrt "+str(s2)+ ") (sqrt "+str(s3)+")  ) (e1 " +str(e1x)+" "+ str(e1y)+" " +str(-z)+ " ) (e2" +str(e2x)+" "+ str(e2y)+" " +str(-z)+ ") (e3 "+str(e3x)+" "+ str(e3y)+" " +str(-z)+ ") ) \n")     
f.write(" ))")
f.close()  
      
    
     
